//+------------------------------------------------------------------+
//|                                           e_SM_CH_CCI_WPR_01.mq4 |
//+------------------------------------------------------------------+
#property copyright "fion"
#property link      ""

extern string t="-----------  -----------";
extern int    Start_Monday_Minuts = 5;//      .
extern string MA_CH ="------MA_Channel--------";
extern int    Ma_period        = 50; //    
extern int    Ma_channel       = 10; //   ( )        
extern int    Ma_shift         =  0; //    
extern int    Ma_type          =  0; //    
extern int    Ma_price         =  0; //      (7 )
extern string WPR="---------- WPR  ----------";
extern int    WPR_period      =       18;
extern int    WPR_level_high  =      -20;
extern int    WPR_level_low   =      -80;
extern string CCI="---------- CCI  ----------";
extern int    CCIPeriod       =       14;
extern int    CCI_price       = PRICE_CLOSE;
extern int    CCI_level_high  =      100;
extern int    CCI_level_low   =     -100;
extern string ts=" ----    ------";
extern int    Stop_BU          =       0; //    () 0-.
extern int    TrailingStop     =       0; //   0- .  
extern int    TrailingStep     =       5; //   
extern string all="--------   --------- ";
extern bool   Long_Position   =     true; //  
extern bool   Short_Position  =     true; //  
extern bool   CloseReversSig  =     true; //      
extern double Max_spread      =       10; //     
extern int    Sl              =       50; //  - 0-. 
extern int    Tp              =       50; //  - 0-.
extern double Lots            =     0.01; //     
extern string MM_type="----   :   0-, 1 -  , 2 -   -------";
extern int    Martin_Type      =       0; //0- . 1-      , 2 -    
extern double Risk             =       0; // risk (Lots=Balance*0.001*Risk) 0-.
extern double Lots_exp         =       2; //   
extern string servis="------ ------";
extern string Order_omment    = "SM_CH_CCI_WPR";
extern int    Magic            =     717; // 
extern bool   Auto_4_digits    =    true; // 
extern bool   OpenPlay         =    true; //     
//.............................................................................
int    BARS,pos,close_pos,prevtime,mp,minstop,last_open,open;
double op,sl,tp,price,minlot,maxlot,lotstep;
string comm,gl_timeseria,LastOrderComment;
int    orders_buy,orders_sell,LastInputTime,open_timeseria;
double LastOpenPriseOpenBuy,LastOpenPriseOpenSell,BuyLots,SellLots;
double LastOpenBuySL,LastOpenSellSL,LastOpenBuyTP,LastOpenSellTP,LastOpenBuyLots,LastOpenSellLots;
int    LastOpenSellMagic,LastOpenBuyTicket,LastOpenSellTicket;
datetime OpenBuyTime,OpenSellTime; double PrevCl,CurrCl,BuyProfit,SellProfit;
int orders_seria,LastCloseType,TimeSleep,LastCloseTime,LastTimeChannel;
double HistProfitSeria,LastCloseLots,LastCloseProfit;
//--------------------------------------------------------------------
//--------------------------------------------------------------------
double NL(double lots)
  {
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double StepLots=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot=NormalizeDouble(lots/StepLots,0)*StepLots;
   if(lot>MaxLots) lot=MaxLots;
   if(lot<MinLots) lot=MinLots;
   return (lot);
  }
double ND(double x){return(NormalizeDouble(x,Digits));}
//--------------------------------------------------------------------
double Lots()
  {
   double lots=Lots;
   if(Risk>0)lots=AccountBalance()*0.001*Risk;
   return(NL(lots));
  }
//--------------------------------------------------------------------
//---------------------------------------------------------------------
double SeriaHistory(int OpenTimeSeria)
  {
   int time=0;  orders_seria=0;  HistProfitSeria=0; LastCloseType=-1;
   LastCloseLots=0; LastCloseProfit=0;
   if(OpenTimeSeria==0)return(0);// no seria
   else
     {
      for(int i=OrdersHistoryTotal();i>=1;i--)
        {
         if(OrderSelect(i-1,SELECT_BY_POS,MODE_HISTORY))
            if(OrderSymbol()!=Symbol())continue;
         if(OrderMagicNumber()!=Magic)continue;
         if(OrderCloseTime()<=OpenTimeSeria)continue;
         if(OrderType()<=1)
           {
            orders_seria++;
            HistProfitSeria+=OrderProfit()+OrderSwap();
            if(OrderCloseTime()>time)
              {
               time=OrderCloseTime();
               LastCloseLots= OrderLots();
               LastCloseType= OrderType();
               LastCloseProfit=OrderProfit()-OrderSwap();
              }
           }
        }
     }
//Print("   ",LastCloseProfit); 
   return(HistProfitSeria);
  }
//--------------------------------------------------------------------
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----  -----
   mp=1; if(Auto_4_digits)if(Digits==3 || Digits==5)mp=10;
   Sl*=mp; Tp*=mp; Ma_channel*=mp;
   BARS=Bars;open=1;
   return(0);
  }

int deinit(){Comment("");return(0);}
//--------------------------------------------------------------------
int Signal()
  {
   double ma=iMA(Symbol(),0,Ma_period,Ma_shift,Ma_type,Ma_price,1),close=Close[1];
   if(close>ma+Ma_channel*Point || close<ma-Ma_channel*Point)
     {
      double cci=iCCI(Symbol(),0,CCIPeriod,CCI_price,1);
      double wpr=iWPR(Symbol(),0,WPR_period,1);
      if(close>ma+Ma_channel*Point && cci<CCI_level_low  && wpr<WPR_level_low )return( 1);
      if(close<ma-Ma_channel*Point && cci>CCI_level_high && wpr>WPR_level_high)return(-1);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(!IsTradeAllowed())return(0);
   RefreshRates(); Comment("");
   int Status=OrdersScaner();
//tral
   if(Status!=0 && Stop_BU+TrailingStop>0)Tral();
//comment
   if(Start_Monday_Minuts>0)
   if(DayOfWeek()==1 && TimeCurrent()-iTime(NULL,1440,0)<Start_Monday_Minuts*60)
     {Comment("\n    ",Start_Monday_Minuts,"   ");return(0);}
//new bar  
   if(Bars==BARS)return(0);
   BARS=Bars;
//signal
   int signal=Signal();
//close
   if(CloseReversSig)
     {
      if(orders_buy >0)if(signal==-1){CloseAll(0);Status=OrdersScaner();}
      if(orders_sell>0)if(signal== 1){CloseAll(1);Status=OrdersScaner();}
     }
//block
   if(orders_buy+orders_sell>0)return(0);
   if(signal== 0)return(0);
   if(Ask-Bid>Max_spread*Point*mp)return(0);   
//martingal
   if(Martin_Type==0)double lots=Lots();
   else
     {
      SeriaHistory(open_timeseria);
      if(Martin_Type==2)
        {
         if(HistProfitSeria<0)
           {
            if(LastCloseProfit<0)lots=LastCloseLots*Lots_exp;
            else lots=LastCloseLots;
           }
         else {lots=Lots(); open_timeseria=TimeCurrent();}
        }
      if(Martin_Type==1)
        {
         if(LastCloseProfit<0)lots=LastCloseLots*Lots_exp;
         else {lots=Lots(); open_timeseria=TimeCurrent();}
        }
     }
//input long
   if(Long_Position && signal==1)
      if(OpenBuyMarket(Magic,NL(lots),0,Sl,0,Tp,Order_omment,Blue)>0)
        {if(OpenPlay)ALERT(1);open=0; return(0);}
   else 
     {
      Print("    BUY  - ",GetLastError());
      Sleep(5000);BARS-=1;
     }
//input short
   if(Short_Position && signal==-1)
      if(OpenSellMarket(Magic,NL(lots),0,Sl,0,Tp,Order_omment,Red)>0)
        {if(OpenPlay)ALERT(-1);open=0; return(0);}
   else 
     {
      Print("    SELL  - ",GetLastError());
      Sleep(5000);BARS-=1;
     }
//--- end
   return(0);
  }
//--------------------------------------------------------------------
void ALERT(int type)
  {
   if(type== 1)Alert("  ",Symbol(),"   ",Ask,"  - ",TimeToStr(TimeCurrent()));
   if(type==-1)Alert("  ",Symbol(),"   ",Bid,"  - ",TimeToStr(TimeCurrent()));
  }
//--------------------------------------------------------------------
int OrdersScaner()
  {
//------------------  ---------      
   orders_buy=0;orders_sell=0;
   LastOpenPriseOpenBuy=0;LastOpenPriseOpenSell=0;LastOpenBuySL=0;  LastOpenSellSL=0;
   LastOpenBuyTP=0;  LastOpenSellTP=0; LastOpenBuyTicket=0;LastOpenSellTicket=0;
   OpenBuyTime=0;OpenSellTime=0; LastOpenBuyLots=0; LastOpenSellLots=0;
   BuyLots=0;SellLots=0; LastOrderComment=""; BuyProfit=0;SellProfit=0;
//----   
   for(int i=OrdersTotal();i>=1;i--)
     {
      if(OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES)==FALSE)break;
      if(OrderSymbol()!=Symbol())continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderType()==OP_BUY)
        {
         if(OpenBuyTime<OrderOpenTime())
           {
            OpenBuyTime=OrderOpenTime(); LastOpenPriseOpenBuy=OrderOpenPrice();
            LastOpenBuyTP=OrderTakeProfit();LastOpenBuySL=OrderStopLoss();
            LastOrderComment=OrderComment();
            LastOpenBuyTicket=OrderTicket();LastOpenBuyLots=OrderLots();
           }
         orders_buy++;
         BuyLots+=OrderLots();BuyProfit+=OrderProfit()+OrderSwap();
        }
      if(OrderType()==OP_SELL)
        {
         if(OpenSellTime<OrderOpenTime())
           {
            OpenSellTime=OrderOpenTime(); LastOpenPriseOpenSell=OrderOpenPrice();
            LastOpenSellTP=OrderTakeProfit();LastOpenSellSL=OrderStopLoss();
            LastOrderComment=OrderComment();
            LastOpenSellTicket=OrderTicket();LastOpenSellLots=OrderLots();
           }
         orders_sell++;
         SellLots+=OrderLots();SellProfit+=OrderProfit()+OrderSwap();
        }

     }
   int status=0;
//---   
   if(orders_buy+orders_sell>0)status=1;
   return(status);
  }
//--------------------------------------------------------------------------------------
int OpenBuyMarket(int magic,double lots,double ST,int SL,double TK,int TP,string _comm,color clr)
  {
   if(AccountFreeMarginCheck(Symbol(),OP_BUY,lots)<=0 || GetLastError()==134)/* NOT_ENOUGH_MONEY */
     {
      Print("        ");
      Comment("        "); Sleep(5000);return(0);
     }
   while(IsTradeContextBusy()) Sleep(1000); RefreshRates();
   double ask=NormalizeDouble(Ask,Digits);
   int ticket=OrderSend(Symbol(),OP_BUY,lots,ask,3*mp,0,0,_comm,magic,0,clr);
   if(ticket>0)
     {
      if(SL+TP+ST+TK>0)
        {
         if(OrderSelect(ticket,SELECT_BY_TICKET))
           {
            while(IsTradeContextBusy()) Sleep(1000); RefreshRates();
            op=OrderOpenPrice();
            minstop=MarketInfo(Symbol(),MODE_STOPLEVEL);
            if(SL!=0) sl = ND(op-SL*Point); else sl = 0;
            if(ST!=0) sl = ND(ST);
            if(TP!=0) tp = ND(op+TP*Point); else tp = 0;
            if(TK!=0) tp = ND(TK);
            if(tp!=0)if(tp-Ask<minstop*Point)tp=Ask+minstop*Point;
            if(sl!=0)if(Bid-sl<minstop*Point)sl=Bid-minstop*Point;
            if(!OrderModify(ticket,op,sl,tp,0,Blue))
               Print("    BUY ",GetLastError());
            else return(ticket);
           }
        }
      else  return(ticket);
     }
   else { Print("   BUY ",GetLastError());  return(0);}
   return(ticket);
  }
//--------------------------------------------------------------------
//--------------------------------------------------------------------
int OpenSellMarket(int magic,double lots,double ST,int SL,double TK,int TP,string _comm,color clr)
  {
   if(AccountFreeMarginCheck(Symbol(),OP_SELL,lots)<=0 || GetLastError()==134)/* NOT_ENOUGH_MONEY */
     {
      Print("        ");
      Comment("        "); Sleep(5000);return(0);
     }
   while(IsTradeContextBusy()) Sleep(1000); RefreshRates();
   double bid=NormalizeDouble(Bid,Digits);
   int ticket=OrderSend(Symbol(),OP_SELL,lots,bid,3*mp,0,0,_comm,magic,0,clr);
   if(ticket>0)
     {
      if(SL+TP+ST+TK>0)
        {
         if(OrderSelect(ticket,SELECT_BY_TICKET))
           {
            while(IsTradeContextBusy()) Sleep(1000); RefreshRates();
            op=OrderOpenPrice();
            minstop=MarketInfo(Symbol(),MODE_STOPLEVEL);
            if(SL!=0) sl = ND(op+SL*Point); else sl = 0;
            if(ST!=0) sl = ND(ST);
            if(TP!=0) tp = ND(op-TP*Point); else tp = 0;
            if(TK!=0) tp = ND(TK);
            if(tp!=0)if(Bid-tp<minstop*Point)tp=Bid-minstop*Point;
            if(sl!=0)if(sl-Ask<minstop*Point)sl=Ask+minstop*Point;
            if(!OrderModify(ticket,op,sl,tp,0,Red))
               Print("    SELL ",GetLastError());
            else return(ticket);
           }
        }
      else  return(ticket);
     }
   else { Print("   SELL ",GetLastError()); return(0);}
   return(ticket);
  }
//---------------------------------------------------------------------------
//--------------------------------------------------------------------
int CloseAll(int type)
  {//    
//Print("  "); 
   bool   UseSound        = 0;
   int    Slippage        = 5*mp;    //  
   int    NumberOfTry     = 4;       //  
   int    PauseAfterError = 5;       //     
   color clCloseBuy  = Blue;         //    
   color clCloseSell = Red;          //    
   string NameFileSound="";

   bool   fc;
   double pp;
   int    err,i,it,cnt=0,magic;

   for(i=OrdersTotal()-1; i>=0; i--) 
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) 
        {
         if(OrderSymbol()==Symbol())
           {
            if(type!=-1)if(OrderType()!=type)continue;
            magic=OrderMagicNumber();
            if(magic==Magic)
              {
               fc=False;
               for(it=1; it<=NumberOfTry; it++) 
                 {
                  while(!IsTradeAllowed()) Sleep(500);
                  RefreshRates();
                  if(OrderType()==OP_BUY) 
                    {
                     pp=MarketInfo(OrderSymbol(), MODE_BID);
                     fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
                     if(fc) {if(UseSound) PlaySound(NameFileSound); break;}
                     else { err=GetLastError(); Print("Error",err);Sleep(1000*PauseAfterError);}
                    }
                  if(OrderType()==OP_SELL) 
                    {
                     pp=MarketInfo(OrderSymbol(), MODE_ASK);
                     fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
                     if(fc) {if(UseSound) PlaySound(NameFileSound); break;}
                     else {err=GetLastError(); Print("Error",err); Sleep(1000*PauseAfterError);}
                    }
                 }
              }
           }
        }
     }
//---------    ---------------
   for(i=OrdersTotal()-1; i>=0; i--) 
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()!=Symbol()) continue;
      if(type!=-1)if(OrderType()!=type)continue;
      magic=OrderMagicNumber();
      if(magic!=Magic) continue;
      if(OrderType()==OP_BUY || OrderType()==OP_SELL)cnt++;
     }
   if(cnt==0)return(1);
   else return (0);
  }
//--------------------------------------------------------------------- 
//-----------------------------------------------------------------------------------
void Tral()
  {
   if(Martin_Type==1){SeriaHistory(open_timeseria); if(orders_seria>0)return;}
   minstop=MarketInfo(Symbol(),MODE_STOPLEVEL); int k_8=mp;
   if(minstop==0)minstop+=1;
   int Orders= OrdersTotal(); double stop,bid,ask,new_stop;
   for(int i=0; i<=Orders; i++) 
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()!=Symbol()) continue;
         if(OrderMagicNumber()!=Magic) continue;
         //---
         if(OrderType()==OP_BUY) 
           {
            while(IsTradeContextBusy()) Sleep(1000); RefreshRates();
            bid=Bid; stop=OrderStopLoss(); op=OrderOpenPrice();
            new_stop=stop;
            if(Stop_BU>0 && stop<op)
               if(bid-op>Stop_BU*k_8*Point)new_stop=op+1*k_8*Point;

            if(TrailingStop>0)
               if((Stop_BU>0 && stop>op) || Stop_BU==0)
                  if(stop<bid-(TrailingStop+TrailingStep-1)*k_8*Point || stop==0) new_stop=bid-TrailingStop*k_8*Point;

            if(new_stop<=stop || new_stop==0)continue;
            if(new_stop!=0 && bid-new_stop>minstop*Point)
              {
               if(!OrderModify(OrderTicket(),op,NormalizeDouble(new_stop,Digits),OrderTakeProfit(),0,Aqua))
                 {Print("   -,  - ",GetLastError()); Sleep(1000);}

              }
           }
         if(OrderType()==OP_SELL) 
           {
            while(IsTradeContextBusy()) Sleep(1000); RefreshRates();
            ask=Ask;stop=OrderStopLoss(); op=OrderOpenPrice();
            new_stop=stop;
            if(Stop_BU>0 && (stop>op || stop==0))
               if(op-ask>Stop_BU*k_8*Point)new_stop=op-1*k_8*Point;

            if(TrailingStop>0)
               if((Stop_BU>0 && stop!=0 && stop<op) || Stop_BU==0)
                  if(stop>ask+(TrailingStop+TrailingStep-1)*k_8*Point || stop==0)
                     new_stop=ask+TrailingStop*k_8*Point;

            if(new_stop!=stop && new_stop-ask>minstop*Point)
              {
               if(!OrderModify(OrderTicket(),op,NormalizeDouble(new_stop,Digits),OrderTakeProfit(),0,Lime))
                 {Print("   -,  - ",GetLastError()); Sleep(1000); }

              }
           }
        }
     }
  }
//---------------------------------------------------------------------------
////////////////////////////////// END///////////////////////////////////////////////
